/*
 * @Author       : ChenJie
 * @Date         : 2022-01-23 13:45:09
 * @Version      : V3.0
 * @LastEditors  : ChenJie
 * @LastEditTime : 2022-05-17 18:37:07
 * @Description  : file content
 * @FilePath     : \S32K146_4G\src\AppGlobalVar.h
 */
/*
 * AppGlobal.h
 *      Author: QiXiang_CHENJIE
 */
#ifndef APPGLOBALVAR_H_
#define APPGLOBALVAR_H_

//#define APP_UART0_ENABLE
#define APP_CAN_ENABLE

#include "hal_adapter.h"
// test Var
//#define defaultSn "GYTEST00000000001"
#define defaultSn "CQHZHL128N2236001"
#define BATT_SN_LEN 17
#define HWVERSION 0x0001
#define BLSWVERSION 0x00000001
#define DRVSWVERSION 0x00000001
#define APPSWVERSION 0x00000104
#define BMS_MANUFACTURE 0xFF
#define BMS_INFO 0xFF
#define DATA_MODULE_TYPE 0x02

#define BMS_CELL_MAX_NUM 184
#define BMS_TEMP_MAX_NUM 96


extern uint8 TcpbattSN[17];
extern uint8 VIN[17];
extern volatile uint32 TimerCounter;
extern uint32 BattTempR[4];
extern uint16 ErrorArray[10];
extern uint8 Fota_update_flag;
typedef struct
{
    uint8 RealLen;
    uint8 *DataPtr;
} QueueDataTrans_Type;
/*GPS*/
extern QueueHandle_t GpsDataQueueHandle;
extern sint16 xyzData[3];
/*Hal_Can*/
extern uint8 CanIf_u8TxConfirmCnt;
extern boolean CanIf_bTxFlag;
extern uint8 CanIf_u8RxIndicationCnt;
extern boolean CanIf_bRxFlag;
extern QueueHandle_t CanRecvQueueHandle;
/*Fota*/
typedef struct _Fota_Type
{
    bool Fota_update_error;
    uint32 Fota_All_Data_Len;
    uint32 Fota_Current_Addres;
    uint8 Fota_Recv_Data_Len;
    uint8 Fota_Recv_Data[100];
    uint32 Fota_Flash_Addres;
    uint8 Fota_CRC;
} Fota_Type;

extern uint8 CSQValue;
extern sint8 SocketId;
extern sint8 RegChkRet;
extern char WebSiteIp[20];
extern const char WebSiteName[];
extern const uint16 WebSitePort;
extern char ImeiNum[15];
extern char IccidNum[20];
extern uint8 TcpWorkState;
typedef struct _AppConfigType
{
    bool appSaveFlg;
    bool eolFlg;
    uint8 deviceSn[17];
    uint8 re[20];
} AppConfigBody;
extern AppConfigBody AppConfigInfo;


#ifdef APP_CAN_ENABLE
extern uint8 vehicleStatus;
extern uint8 bmsHVOn;
extern uint8 currentGearPosition;
extern uint8 parkingBreakStatus;
extern uint8 breakingStatus;
extern uint32 ODO;
extern uint8 dcdcWorkStatus;
extern uint8 numOfChrgableSubsys;
extern uint8 chrgableSubsysCode;
extern uint16 vcuDCVol;
// EBC
extern uint8 ebcStatus;
extern uint8 ebcAskHVOn;
extern uint8 ebcAskHVOff;
extern uint8 retainLockSignal;
extern uint8 dischargeLockSignal;
extern uint8 chargeLockSignal;
extern uint8 chargeFlag;

extern UINT32 canMsgNoRecvCounter;

extern UINT32 BcuInTable[71];
extern BOOL BcuRxShortError[71];
extern BOOL BcuRxLongError[71];
extern UINT8 BcuRxErrorCounter[71];
extern UINT8 BcuRxFlag[71];
extern UINT8 VcuBcuOperModReq;
extern UINT8 BcuErrRank;
extern UINT8 BcuErrNum;
extern UINT8 BcuUpAlw;
extern UINT8 BcuOperMod;
extern UINT8 BcuChrgMod;
extern UINT8 BcuChrgSt;
extern UINT8 BcuChrgEndReason;
extern UINT8 BcuCellNr;
extern UINT8 BcuModT[96];

// declear the UINT16 vars
extern UINT16 BcuSoc;
extern UINT16 BcuErrCode;
extern UINT16 BcuInsulationR;
extern UINT16 BcuBattI1;
extern UINT16 BcuBattI2;
extern UINT16 BcuBattU1;
extern UINT16 BcuBattU2;
extern UINT16 BcuChrgIReq;
extern UINT16 BcuChrgUReq;
extern UINT16 BcuReChrgTm;
extern UINT16 BcuDisChrPwrMaxLong;
extern UINT16 BcuSoh;
extern UINT16 BcuCellCap;
extern UINT16 BcuCellR;
extern UINT16 BcuReEgy;
extern UINT16 BcuSoe;
extern UINT16 BcuAhSoc;
extern UINT16 BcuBattSoc;
extern UINT16 BcuEKFSoc;
extern UINT16 BcuEquilist[12];
extern UINT16 BcuCellU[192];
// declear the UINT32 vars
extern UINT32 BcuChrPwrMaxLong;
#endif
#endif /* APPGLOBALVAR_H_ */
