/*
 * AppTaskCan.c
 *
 *  Created on: 2022213
 *      Author: QiXiang_CHENJIE
 */
#include "AppTaskCan.h"
#ifdef APP_CAN_ENABLE
uint32 timerCounterNow = 0;
static uint8 BattSendFlg = 0;
static void UDSAnsFunc(uint8 *rawData);
static void UdsAns(bool PosFlg, uint8 UdsService, uint8 UdsSubService, uint8 Idx, uint8 *AnsData, uint8 AnsDataLen);
static void BattSendFunc(void);
static void vCanRxCallback(TimerHandle_t pxTimer)
{
	uint32 ulTimerID;
	ulTimerID = (uint32)pvTimerGetTimerID(pxTimer);
	if (ulTimerID == 0)
	{
		Can_MainFunction_Read();
	}
}
void CanTask(void *pvParameters)
{
	(void)pvParameters;
	CanIf_bRxFlag = false;
	Can_Msg_Type_Data CanRxMsg;
	CanRecvQueueHandle = xQueueCreate(100, sizeof(Can_Msg_Type_Data));
	TimerHandle_t monitorTimer1ms;
	monitorTimer1ms = xTimerCreate("monitor1ms", 1, pdTRUE, (void *)0, vCanRxCallback);
	xTimerStart(monitorTimer1ms, 0);
	BaseType_t ret = pdFALSE;
	GsensorInit();
	UINT32 BmsPwrOnConuter = 0;
	Dio_LevelType StdFlgret= STD_OFF;
	while (1)
	{
		do
		{
			memset(&CanRxMsg, 0, sizeof(CanRxMsg));
			ret = xQueueReceive(CanRecvQueueHandle, &CanRxMsg, 1);
			if (ret == pdPASS)
			{
				canMsgNoRecvCounter = 0;
				if (IsJumptoBootloader(CanRxMsg.id, CanRxMsg.data))
				{
					DoRoutinePositiveAnswer();
					RequestEnterBootloader();
					DoResetECU();
					break;
				}
				else
				{
					BcuDecodeFunction(CanRxMsg.id, CanRxMsg.data); // canЭ
				}
			}
		} while (ret == pdPASS);
		SL_SC7A20_Read_XYZ_Data(xyzData);
		if (BattSendFlg)
		{
			BattSendFunc();
		}
		if ((TimerCounter - timerCounterNow) > 100)
		{
			canMsgNoRecvCounter++;
			BcuRxDiagnose();
			timerCounterNow = TimerCounter;
			ADC_ReadValue();
			if(StdFlgret == STD_ON)
			{
				BmsPwrOnConuter++;
			}
			else
			{
				BmsPwrOnConuter = 0;
			}

		}
		if (canMsgNoRecvCounter >= 10 * 60 * 60)
		{
			canMsgNoRecvCounter = 0;
			Dio_WriteChannel(DioConf_DioChannel_PTA11_GPIO_OUT_MCU_BMS_WAKEUP_EN, STD_ON);
			StdFlgret = STD_ON;
		}
		if(BmsPwrOnConuter >= 10 * 60 * 5)
		{
			Dio_WriteChannel(DioConf_DioChannel_PTA11_GPIO_OUT_MCU_BMS_WAKEUP_EN, STD_OFF);
			BmsPwrOnConuter = 0;
			StdFlgret = STD_OFF;
		}
	}
}
//ע볬
void BcuDecodeFunction(uint32 ID, uint8 *rawData)
{
	switch (ID)
	{
	case 0x721:
		VcuBcuOperModReq = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0x1);
		BcuRxFlag[0] = 0x01;
		break;
	case 0x830:
		BcuSoc = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuErrCode = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuErrRank = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xF);
		BcuErrNum = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0x7F);
		BcuUpAlw = (UINT8)(((*(UINT8 *)(rawData + 5)) >> 7) & 0x1);
		BcuInsulationR = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFF);
		BcuOperMod = (UINT8)(((*(UINT8 *)(rawData + 7)) >> 4) & 0xF);
		BcuRxFlag[1] = 0x01;
		break;
	case 0x831:
		BcuBattI1 = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuBattI2 = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuBattU1 = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuBattU2 = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[2] = 0x01;
		break;
	case 0x832:
		BcuChrgMod = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xF);
		BcuChrgSt = (UINT8)(((*(UINT8 *)(rawData + 0)) >> 4) & 0xF);
		BcuChrgIReq = (UINT16)(((*(UINT8 *)(rawData + 1)) | (*(UINT8 *)(rawData + 2) << 8)) & 0xFFFF);
		BcuChrgUReq = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuReChrgTm = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuChrgEndReason = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuRxFlag[3] = 0x01;
		break;
	case 0x833:
		BcuDisChrPwrMaxLong = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuChrPwrMaxLong = (UINT32)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8) | (*(UINT8 *)(rawData + 4) << 16) | (*(UINT8 *)(rawData + 5) << 24)) & 0xFFFFFFFF);
		BcuRxFlag[4] = 0x01;
		break;
	case 0x834:
		BcuSoh = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellNr = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuCellCap = (UINT16)(((*(UINT8 *)(rawData + 3)) | (*(UINT8 *)(rawData + 4) << 8)) & 0xFFFF);
		BcuCellR = (UINT16)(((*(UINT8 *)(rawData + 5)) | (*(UINT8 *)(rawData + 6) << 8)) & 0xFFFF);
		BcuRxFlag[5] = 0x01;
		break;
	case 0x835:
		BcuReEgy = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuSoe = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuRxFlag[6] = 0x01;
		break;
	case 0x837:
		BcuAhSoc = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuBattSoc = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuEKFSoc = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuRxFlag[7] = 0x01;
		break;
	case 0x840:
		BcuEquilist[0] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuEquilist[1] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuEquilist[2] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuEquilist[3] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[8] = 0x01;
		break;
	case 0x841:
		BcuEquilist[4] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuEquilist[5] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuEquilist[6] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuEquilist[7] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[9] = 0x01;
		break;
	case 0x842:
		BcuEquilist[8] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuEquilist[9] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuEquilist[10] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuEquilist[11] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[10] = 0x01;
		break;
	case 0x843:
		BcuCellU[0] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[1] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[2] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[3] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[11] = 0x01;
		break;
	case 0x844:
		BcuCellU[4] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[5] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[6] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[7] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[12] = 0x01;
		break;
	case 0x845:
		BcuCellU[8] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[9] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[10] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[11] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[13] = 0x01;
		break;
	case 0x846:
		BcuCellU[12] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[13] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[14] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[15] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[14] = 0x01;
		break;
	case 0x847:
		BcuCellU[16] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[17] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[18] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[19] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[15] = 0x01;
		break;
	case 0x848:
		BcuCellU[20] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[21] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[22] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[23] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[16] = 0x01;
		break;
	case 0x849:
		BcuCellU[24] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[25] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[26] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[27] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[17] = 0x01;
		break;
	case 0x84A:
		BcuCellU[28] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[29] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[30] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[31] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[18] = 0x01;
		break;
	case 0x84B:
		BcuCellU[32] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[33] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[34] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[35] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[19] = 0x01;
		break;
	case 0x84C:
		BcuCellU[36] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[37] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[38] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[39] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[20] = 0x01;
		break;
	case 0x84D:
		BcuCellU[40] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[41] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[42] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[43] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[21] = 0x01;
		break;
	case 0x84E:
		BcuCellU[44] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[45] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[46] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[47] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[22] = 0x01;
		break;
	case 0x84F:
		BcuCellU[48] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[49] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[50] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[51] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[23] = 0x01;
		break;
	case 0x850:
		BcuCellU[52] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[53] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[54] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[55] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[24] = 0x01;
		break;
	case 0x851:
		BcuCellU[56] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[57] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[58] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[59] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[25] = 0x01;
		break;
	case 0x852:
		BcuCellU[60] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[61] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[62] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[63] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[26] = 0x01;
		break;
	case 0x853:
		BcuCellU[64] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[65] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[66] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[67] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[27] = 0x01;
		break;
	case 0x854:
		BcuCellU[68] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[69] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[70] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[71] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[28] = 0x01;
		break;
	case 0x855:
		BcuCellU[72] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[73] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[74] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[75] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[29] = 0x01;
		break;
	case 0x856:
		BcuCellU[76] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[77] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[78] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[79] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[30] = 0x01;
		break;
	case 0x857:
		BcuCellU[80] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[81] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[82] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[83] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[31] = 0x01;
		break;
	case 0x858:
		BcuCellU[84] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[85] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[86] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[87] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[32] = 0x01;
		break;
	case 0x859:
		BcuCellU[88] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[89] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[90] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[91] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[33] = 0x01;
		break;
	case 0x85A:
		BcuCellU[92] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[93] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[94] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[95] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[34] = 0x01;
		break;
	case 0x85B:
		BcuCellU[96] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[97] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[98] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[99] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[35] = 0x01;
		break;
	case 0x85C:
		BcuCellU[100] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[101] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[102] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[103] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[36] = 0x01;
		break;
	case 0x85D:
		BcuCellU[104] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[105] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[106] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[107] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[37] = 0x01;
		break;
	case 0x85E:
		BcuCellU[108] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[109] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[110] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[111] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[38] = 0x01;
		break;
	case 0x85F:
		BcuCellU[112] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[113] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[114] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[115] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[39] = 0x01;
		break;
	case 0x860:
		BcuCellU[116] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[117] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[118] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[119] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[40] = 0x01;
		break;
	case 0x861:
		BcuCellU[120] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[121] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[122] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[123] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[41] = 0x01;
		break;
	case 0x862:
		BcuCellU[124] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[125] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[126] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[127] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[42] = 0x01;
		break;
	case 0x863:
		BcuCellU[128] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[129] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[130] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[131] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[43] = 0x01;
		break;
	case 0x864:
		BcuCellU[132] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[133] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[134] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[135] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[44] = 0x01;
		break;
	case 0x865:
		BcuCellU[136] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[137] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[138] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[139] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[45] = 0x01;
		break;
	case 0x866:
		BcuCellU[140] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[141] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[142] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[143] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[46] = 0x01;
		break;
	case 0x867:
		BcuCellU[144] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[145] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[146] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[147] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[47] = 0x01;
		break;
	case 0x868:
		BcuCellU[148] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[149] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[150] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[151] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[48] = 0x01;
		break;
	case 0x869:
		BcuCellU[152] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[153] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[154] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[155] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[49] = 0x01;
		break;
	case 0x86A:
		BcuCellU[156] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[157] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[158] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[159] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[50] = 0x01;
		break;
	case 0x86B:
		BcuCellU[160] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[161] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[162] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[163] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[51] = 0x01;
		break;
	case 0x86C:
		BcuCellU[164] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[165] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[166] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[167] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[52] = 0x01;
		break;
	case 0x86D:
		BcuCellU[168] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[169] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[170] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[171] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[53] = 0x01;
		break;
	case 0x86E:
		BcuCellU[172] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[173] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[174] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[175] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[54] = 0x01;
		break;
	case 0x86F:
		BcuCellU[176] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[177] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[178] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[179] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[55] = 0x01;
		break;
	case 0x870:
		BcuCellU[180] = (UINT16)(((*(UINT8 *)(rawData + 0)) | (*(UINT8 *)(rawData + 1) << 8)) & 0xFFFF);
		BcuCellU[181] = (UINT16)(((*(UINT8 *)(rawData + 2)) | (*(UINT8 *)(rawData + 3) << 8)) & 0xFFFF);
		BcuCellU[182] = (UINT16)(((*(UINT8 *)(rawData + 4)) | (*(UINT8 *)(rawData + 5) << 8)) & 0xFFFF);
		BcuCellU[183] = (UINT16)(((*(UINT8 *)(rawData + 6)) | (*(UINT8 *)(rawData + 7) << 8)) & 0xFFFF);
		BcuRxFlag[56] = 0x01;
		break;
	case 0x871:
		BcuRxFlag[57] = 0x01;
		break;
	case 0x872:
		BcuRxFlag[58] = 0x01;
		break;
	case 0x873:
		BcuModT[0] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[1] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[2] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[3] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[4] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[5] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[6] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[7] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[59] = 0x01;
		break;
	case 0x874:
		BcuModT[8] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[9] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[10] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[11] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[12] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[13] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[14] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[15] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[60] = 0x01;
		break;
	case 0x875:
		BcuModT[16] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[17] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[18] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[19] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[20] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[21] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[22] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[23] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[61] = 0x01;
		break;
	case 0x876:
		BcuModT[24] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[25] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[26] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[27] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[28] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[29] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[30] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[31] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[62] = 0x01;
		break;
	case 0x877:
		BcuModT[32] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[33] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[34] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[35] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[36] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[37] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[38] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[39] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[63] = 0x01;
		break;
	case 0x878:
		BcuModT[40] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[41] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[42] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[43] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[44] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[45] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[46] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[47] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[64] = 0x01;
		break;
	case 0x879:
		BcuModT[48] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[49] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[50] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[51] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[52] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[53] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[54] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[55] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[65] = 0x01;
		break;
	case 0x87A:
		BcuModT[56] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[57] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[58] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[59] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[60] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[61] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[62] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[63] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[66] = 0x01;
		break;
	case 0x87B:
		BcuModT[64] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[65] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[66] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[67] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[68] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[69] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[70] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[71] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[67] = 0x01;
		break;
	case 0x87C:
		BcuModT[72] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[73] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[74] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[75] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[76] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[77] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[78] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[79] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[68] = 0x01;
		break;
	case 0x87D:
		BcuModT[80] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[81] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[82] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[83] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[84] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[85] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[86] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[87] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[69] = 0x01;
		break;
	case 0x87E:
		BcuModT[88] = (UINT8)(((*(UINT8 *)(rawData + 0))) & 0xFF);
		BcuModT[89] = (UINT8)(((*(UINT8 *)(rawData + 1))) & 0xFF);
		BcuModT[90] = (UINT8)(((*(UINT8 *)(rawData + 2))) & 0xFF);
		BcuModT[91] = (UINT8)(((*(UINT8 *)(rawData + 3))) & 0xFF);
		BcuModT[92] = (UINT8)(((*(UINT8 *)(rawData + 4))) & 0xFF);
		BcuModT[93] = (UINT8)(((*(UINT8 *)(rawData + 5))) & 0xFF);
		BcuModT[94] = (UINT8)(((*(UINT8 *)(rawData + 6))) & 0xFF);
		BcuModT[95] = (UINT8)(((*(UINT8 *)(rawData + 7))) & 0xFF);
		BcuRxFlag[70] = 0x01;
		break;
	case 0x1C00EDEA:
		UDSAnsFunc(rawData);
		break;
	default:
		break;
	}
}
static void UDSAnsFunc(uint8 *rawData)
{
	static uint8 UdsStates = 1;
	uint8 Data[8] = {0};
	memcpy(Data, rawData, 8);
	uint8 UdsService = 0;
	uint8 UdsSubService = 0;
	UdsService = Data[0];
	UdsSubService = Data[1];
	uint8 AnsData[24] = {0};
	static uint8 deviceSnRecvFlg = 0;
	switch (UdsService)
	{
	case 0x10: //ģʽл
	{
		if (UdsSubService == 0x01)
		{
			UdsStates = 0x01; //رUDS
			UdsAns(true, UdsService, UdsSubService, 0x00, NULL, 0);
		}
		else if (UdsSubService == 0x02)
		{
			if (UdsStates == 0x01 || UdsStates == 0x02)
			{
				UdsStates = 0x02; //UDS
				UdsAns(true, UdsService, UdsSubService, 0x00, NULL, 0);
			}
			else
			{
				UdsAns(false, UdsService, UdsSubService, 0x00, NULL, 0);
			}
		}
		break;
	}
	case 0x22: //ѯ
	{
		if (UdsStates == 0x02)
		{
			switch (UdsSubService)
			{
			case 0x01: //汾Ųѯ
			{
				AnsData[0] = APPSWVERSION >> 24;
				AnsData[1] = APPSWVERSION >> 16;
				AnsData[2] = APPSWVERSION >> 8;
				AnsData[3] = APPSWVERSION >> 0;
				UdsAns(true, UdsService, UdsSubService, 0x00, AnsData, 4);
				break;
			}
			case 0x02: // SNѯ
			{
				memcpy(AnsData, AppConfigInfo.deviceSn, 17);
				for (uint8 i = 0; i < 5; i++)
				{
					UdsAns(true, UdsService, UdsSubService, i, &AnsData[i * 4], 4);
				}
				break;
			}
			case 0x03: // ICCIDѯ
			{
				memcpy(AnsData, IccidNum, 20);
				for (uint8 i = 0; i < 5; i++)
				{
					UdsAns(true, UdsService, UdsSubService, i, &AnsData[i * 4], 4);
				}
				break;
			}
			case 0x04: // IMEIѯ
			{
				memcpy(AnsData, ImeiNum, 15);
				for (uint8 i = 0; i < 4; i++)
				{
					UdsAns(true, UdsService, UdsSubService, i, &AnsData[i * 4], 4);
				}
				break;
			}
			case 0x05: //פ״̬ѯ
			{
				AnsData[0] = RegChkRet;
				UdsAns(true, UdsService, UdsSubService, 0x00, AnsData, 1);
				break;
			}
			case 0x06: //״̬ѯ
			{
				AnsData[0] = SocketId;
				UdsAns(true, UdsService, UdsSubService, 0x00, AnsData, 1);
				break;
			}
			case 0x07: //λϢѯ
			{
				GPSInfo GpsRecvData;
				if (xQueuePeek(GpsDataQueueHandle, &GpsRecvData, 0) == pdPASS)
				{
					AnsData[0] = GpsRecvData.locateMark;
					AnsData[4] = GpsRecvData.longitude[0];
					AnsData[5] = GpsRecvData.longitude[1];
					AnsData[6] = GpsRecvData.longitude[2];
					AnsData[7] = GpsRecvData.longitude[3];
					AnsData[8] = GpsRecvData.latitude[0];
					AnsData[9] = GpsRecvData.latitude[1];
					AnsData[10] = GpsRecvData.latitude[2];
					AnsData[11] = GpsRecvData.latitude[3];
					AnsData[12] = GpsRecvData.altitude[0];
					AnsData[13] = GpsRecvData.altitude[1];
					AnsData[14] = GpsRecvData.satelliteNum;
					for (uint8 i = 0; i < 4; i++)
					{
						UdsAns(true, UdsService, UdsSubService, i, &AnsData[i * 4], 4);
					}
					break;
				}
				else
				{
					AnsData[0] = 0xFF;
					UdsAns(true, UdsService, UdsSubService, 0x00, AnsData, 1);
				}
				break;
			}
			case 0x08: //¶ȼѯ
			{
				UdsAns(true, UdsService, UdsSubService, 0x00, AnsData, 1);
				break;
			}
			case 0x09: //Ϣѯ
			{
				UdsAns(true, UdsService, UdsSubService, 0x00, AnsData, 1);
				BattSendFlg = 1;
				break;
			}
			case 0x0A: //ݲѯ
			{
				AnsData[0] = xyzData[0] >> 8;
				AnsData[1] = xyzData[0] >> 0;
				AnsData[2] = xyzData[1] >> 8;
				AnsData[3] = xyzData[1] >> 0;
				AnsData[4] = xyzData[2] >> 8;
				AnsData[5] = xyzData[2] >> 0;
				for (uint8 i = 0; i < 2; i++)
				{
					UdsAns(true, UdsService, UdsSubService, i, &AnsData[i * 4], 4);
				}
				break;
			}
			} // switch
		}	  // if
		else
		{
			UdsAns(false, UdsService, UdsSubService, 0x00, NULL, 0);
		}
		break;
	}
	case 0x27: //
	{
		if (UdsStates == 0x02)
		{
		}
		else
		{
			UdsAns(false, UdsService, UdsSubService, 0x00, NULL, 0);
		}
		break;
	}
	case 0x2E: //д
	{
		if (UdsStates == 0x02)
		{
			switch (UdsSubService)
			{
			case 0x01:
			{
				setbit(deviceSnRecvFlg, Data[3]);
				if (Data[3] < 0x04)
				{
					memcpy(&AppConfigInfo.deviceSn[Data[3] * 4], &Data[4], 4);
					UdsAns(true, UdsService, UdsSubService, 0x00, &Data[3], 1);
				}
				else if (Data[3] == 0x04)
				{
					memcpy(&AppConfigInfo.deviceSn[Data[3] * 4], &Data[4], 1);
					UdsAns(true, UdsService, UdsSubService, 0x00, &Data[3], 1);
				}
				if (deviceSnRecvFlg == 0x1F)
				{
					deviceSnRecvFlg = 0;
					AppConfigInfo.appSaveFlg = true;
				}
				break;
			}
			}
		}
		else
		{
			UdsAns(false, UdsService, UdsSubService, 0x00, NULL, 0);
		}
		break;
	}
	default:
		break;
	}
	return;
}
static void UdsAns(bool PosFlg, uint8 UdsService, uint8 UdsSubService, uint8 Idx, uint8 *AnsData, uint8 AnsDataLen)
{
	Can_Msg_Type CanTxMsg;
	uint32 CanAnsId = 0x1C00EAED;
	uint8 SendData[8] = {0};
	if (PosFlg)
	{
		SendData[0] = 0x78;
		SendData[1] = UdsService;
		SendData[2] = UdsSubService;
		SendData[3] = Idx;
		if (AnsData != NULL && AnsDataLen != 0x00)
		{
			memcpy(&SendData[4], AnsData, AnsDataLen);
		}
	}
	else
	{
		SendData[0] = 0x7F;
		SendData[1] = UdsService;
		SendData[2] = UdsSubService;
		SendData[3] = 0x00;
	}
	CanTxMsg.id = CanAnsId;
	CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
	CanTxMsg.sdu = SendData;
	CanTxMsg.length = 8;
	CanIf_SendMessage(CAN1, CanTxMsg);
}
static void BattSendFunc(void)
{
	Can_Msg_Type CanTxMsg;
	uint32 CanAnsId = 0;
	uint8 SendData[8] = {0};
	static uint8 SendStep = 0;
	static uint8 SendCounter = 0;
	switch (SendStep)
	{
	case 0x00:
	{
		SendStep++;
		return;
		break;
	}
	case 0x01:
	{
		CanAnsId = 0x1C01EAED;
		SendData[0] = 0;
		SendData[1] = 0;
		SendData[2] = 0;
		SendData[3] = 0;
		SendStep++;
		break;
	}
	case 0x02:
	{
		uint16 ErrorTemp;
		ErrorTemp = GetErrorNum(ErrorArray, sizeof(ErrorArray) / 2);
		CanAnsId = 0x1C09EAED;
		SendData[0] = 0;
		SendData[1] = ErrorTemp >> 8;
		SendData[2] = ErrorTemp;
		SendData[3] = 0;
		SendData[4] = 0;
		SendData[5] = 0;
		SendData[6] = 0;
		SendData[7] = 0;
		SendStep++;
		break;
	}
	case 0x03:
	{
		CanAnsId = 0x1C0AEAED;
		SendData[0] = BcuBattI1 >> 8;
		SendData[1] = BcuBattI1;
		SendData[2] = BcuBattU1 >> 8;
		SendData[3] = BcuBattU1;
		SendData[4] = BcuSoc >> 8;
		SendData[5] = BcuSoc;
		SendData[6] = (UINT8)(BcuSoh * 25 / 10);
		SendData[7] = 0;
		SendStep++;
		break;
	}
	case 0x04:
	{
		CanAnsId = 0x1C10EAED + (SendCounter << 16);
		if ((SendCounter * 8 + 7) > BMS_TEMP_MAX_NUM)
		{
			SendCounter = 0;
			SendStep++;
			return;
			break;
		}
		SendData[0] = BcuModT[SendCounter * 8 + 0];
		SendData[1] = BcuModT[SendCounter * 8 + 1];
		SendData[2] = BcuModT[SendCounter * 8 + 2];
		SendData[3] = BcuModT[SendCounter * 8 + 3];
		SendData[4] = BcuModT[SendCounter * 8 + 4];
		SendData[5] = BcuModT[SendCounter * 8 + 5];
		SendData[6] = BcuModT[SendCounter * 8 + 6];
		SendData[7] = BcuModT[SendCounter * 8 + 7];
		SendCounter++;
		break;
	}
	case 0x05:
	{
		CanAnsId = 0x1CA0EAED + (SendCounter << 16);
		if ((SendCounter * 4 + 3) > BMS_CELL_MAX_NUM)
		{
			SendCounter = 0;
			SendStep++;
			return;
			break;
		}
		SendData[0] = BcuCellU[SendCounter * 4 + 0] >> 8;
		SendData[1] = BcuCellU[SendCounter * 4 + 0];
		SendData[2] = BcuCellU[SendCounter * 4 + 1] >> 8;
		SendData[3] = BcuCellU[SendCounter * 4 + 1];
		SendData[4] = BcuCellU[SendCounter * 4 + 2] >> 8;
		SendData[5] = BcuCellU[SendCounter * 4 + 2];
		SendData[6] = BcuCellU[SendCounter * 4 + 3] >> 8;
		SendData[7] = BcuCellU[SendCounter * 4 + 3];
		SendCounter++;
		break;
	}
	default:
	{
		SendStep = 0;
		BattSendFlg = 0;
		return;
		break;
	}
	}
	CanTxMsg.id = CanAnsId;
	CanTxMsg.idFrame = CAN_EXTENDED_ID_TYPE;
	CanTxMsg.sdu = SendData;
	CanTxMsg.length = 8;
	CanIf_SendMessage(CAN1, CanTxMsg);
}

void BcuRxDiagnose(void) // 100msһ
{

	static UINT32 TimeCounter = 0;	// ms
	TimeCounter = TimeCounter + 10; //
	for (UINT8 i = 0; i < sizeof(BcuInTable) / 4; i++)
	{
		if (BcuRxFlag[i] == 1) // received msg, and clear the error conter
		{
			BcuRxErrorCounter[i] = 0;
			BcuRxFlag[i] = 0;
			continue;
		}
		if (BcuRxErrorCounter[i] < 3)
		{
			BcuRxShortError[i] = 0;
			BcuRxLongError[i] = 0;
		}
		else if (BcuRxErrorCounter[i] >= 3 && BcuRxErrorCounter[i] < 13)
		{
			BcuRxShortError[i] = 1;
			BcuRxLongError[i] = 0;
		}
		else if (BcuRxErrorCounter[i] >= 13)
		{
			BcuRxShortError[i] = 0;
			BcuRxLongError[i] = 1;
			BcuRxMsgSetInvalidValue(BcuInTable[i]);
			BcuRxErrorCounter[i] = 0;
		}
		else if (BcuRxErrorCounter[i] == 0xFF)
		{
			BcuRxErrorCounter[i] = 0xFE;
		}
	}
	if (TimeCounter % 100 == 0) // period <=100ms
	{
		BcuRxErrorCounter[0]++; // can msg 0x721
		// if(BcuRxErrorCounter[0]>=13)
		BcuRxErrorCounter[1]++; // can msg 0x830
		// if(BcuRxErrorCounter[1]>=13)
		BcuRxErrorCounter[2]++; // can msg 0x831
		// if(BcuRxErrorCounter[2]>=13)
		BcuRxErrorCounter[3]++; // can msg 0x832
		// if(BcuRxErrorCounter[3]>=13)
		BcuRxErrorCounter[4]++; // can msg 0x833
								// if(BcuRxErrorCounter[4]>=13)
	}
	if (TimeCounter % 1000 == 0) // period ==1000ms
	{
		BcuRxErrorCounter[5]++; // can msg 0x834
		// if(BcuRxErrorCounter[5]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[5]);
		BcuRxErrorCounter[6]++; // can msg 0x835
		// if(BcuRxErrorCounter[6]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[6]);
		BcuRxErrorCounter[7]++; // can msg 0x837
		// if(BcuRxErrorCounter[7]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[7]);
		BcuRxErrorCounter[8]++; // can msg 0x840
		// if(BcuRxErrorCounter[8]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[8]);
		BcuRxErrorCounter[9]++; // can msg 0x841
		// if(BcuRxErrorCounter[9]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[9]);
		BcuRxErrorCounter[10]++; // can msg 0x842
		// if(BcuRxErrorCounter[10]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[10]);
		BcuRxErrorCounter[11]++; // can msg 0x843
		// if(BcuRxErrorCounter[11]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[11]);
		BcuRxErrorCounter[12]++; // can msg 0x844
		// if(BcuRxErrorCounter[12]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[12]);
		BcuRxErrorCounter[13]++; // can msg 0x845
		// if(BcuRxErrorCounter[13]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[13]);
		BcuRxErrorCounter[14]++; // can msg 0x846
		// if(BcuRxErrorCounter[14]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[14]);
		BcuRxErrorCounter[15]++; // can msg 0x847
		// if(BcuRxErrorCounter[15]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[15]);
		BcuRxErrorCounter[16]++; // can msg 0x848
		// if(BcuRxErrorCounter[16]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[16]);
		BcuRxErrorCounter[17]++; // can msg 0x849
		// if(BcuRxErrorCounter[17]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[17]);
		BcuRxErrorCounter[18]++; // can msg 0x84A
		// if(BcuRxErrorCounter[18]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[18]);
		BcuRxErrorCounter[19]++; // can msg 0x84B
		// if(BcuRxErrorCounter[19]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[19]);
		BcuRxErrorCounter[20]++; // can msg 0x84C
		// if(BcuRxErrorCounter[20]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[20]);
		BcuRxErrorCounter[21]++; // can msg 0x84D
		// if(BcuRxErrorCounter[21]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[21]);
		BcuRxErrorCounter[22]++; // can msg 0x84E
		// if(BcuRxErrorCounter[22]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[22]);
		BcuRxErrorCounter[23]++; // can msg 0x84F
		// if(BcuRxErrorCounter[23]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[23]);
		BcuRxErrorCounter[24]++; // can msg 0x850
		// if(BcuRxErrorCounter[24]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[24]);
		BcuRxErrorCounter[25]++; // can msg 0x851
		// if(BcuRxErrorCounter[25]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[25]);
		BcuRxErrorCounter[26]++; // can msg 0x852
		// if(BcuRxErrorCounter[26]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[26]);
		BcuRxErrorCounter[27]++; // can msg 0x853
		// if(BcuRxErrorCounter[27]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[27]);
		BcuRxErrorCounter[28]++; // can msg 0x854
		// if(BcuRxErrorCounter[28]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[28]);
		BcuRxErrorCounter[29]++; // can msg 0x855
		// if(BcuRxErrorCounter[29]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[29]);
		BcuRxErrorCounter[30]++; // can msg 0x856
		// if(BcuRxErrorCounter[30]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[30]);
		BcuRxErrorCounter[31]++; // can msg 0x857
		// if(BcuRxErrorCounter[31]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[31]);
		BcuRxErrorCounter[32]++; // can msg 0x858
		// if(BcuRxErrorCounter[32]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[32]);
		BcuRxErrorCounter[33]++; // can msg 0x859
		// if(BcuRxErrorCounter[33]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[33]);
		BcuRxErrorCounter[34]++; // can msg 0x85A
		// if(BcuRxErrorCounter[34]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[34]);
		BcuRxErrorCounter[35]++; // can msg 0x85B
		// if(BcuRxErrorCounter[35]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[35]);
		BcuRxErrorCounter[36]++; // can msg 0x85C
		// if(BcuRxErrorCounter[36]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[36]);
		BcuRxErrorCounter[37]++; // can msg 0x85D
		// if(BcuRxErrorCounter[37]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[37]);
		BcuRxErrorCounter[38]++; // can msg 0x85E
		// if(BcuRxErrorCounter[38]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[38]);
		BcuRxErrorCounter[39]++; // can msg 0x85F
		// if(BcuRxErrorCounter[39]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[39]);
		BcuRxErrorCounter[40]++; // can msg 0x860
		// if(BcuRxErrorCounter[40]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[40]);
		BcuRxErrorCounter[41]++; // can msg 0x861
		// if(BcuRxErrorCounter[41]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[41]);
		BcuRxErrorCounter[42]++; // can msg 0x862
		// if(BcuRxErrorCounter[42]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[42]);
		BcuRxErrorCounter[43]++; // can msg 0x863
		// if(BcuRxErrorCounter[43]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[43]);
		BcuRxErrorCounter[44]++; // can msg 0x864
		// if(BcuRxErrorCounter[44]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[44]);
		BcuRxErrorCounter[45]++; // can msg 0x865
		// if(BcuRxErrorCounter[45]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[45]);
		BcuRxErrorCounter[46]++; // can msg 0x866
		// if(BcuRxErrorCounter[46]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[46]);
		BcuRxErrorCounter[47]++; // can msg 0x867
		// if(BcuRxErrorCounter[47]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[47]);
		BcuRxErrorCounter[48]++; // can msg 0x868
		// if(BcuRxErrorCounter[48]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[48]);
		BcuRxErrorCounter[49]++; // can msg 0x869
		// if(BcuRxErrorCounter[49]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[49]);
		BcuRxErrorCounter[50]++; // can msg 0x86A
		// if(BcuRxErrorCounter[50]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[50]);
		BcuRxErrorCounter[51]++; // can msg 0x86B
		// if(BcuRxErrorCounter[51]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[51]);
		BcuRxErrorCounter[52]++; // can msg 0x86C
		// if(BcuRxErrorCounter[52]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[52]);
		BcuRxErrorCounter[53]++; // can msg 0x86D
		// if(BcuRxErrorCounter[53]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[53]);
		BcuRxErrorCounter[54]++; // can msg 0x86E
		// if(BcuRxErrorCounter[54]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[54]);
		BcuRxErrorCounter[55]++; // can msg 0x86F
		// if(BcuRxErrorCounter[55]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[55]);
		BcuRxErrorCounter[56]++; // can msg 0x870
		// if(BcuRxErrorCounter[56]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[56]);
		BcuRxErrorCounter[57]++; // can msg 0x871
		// if(BcuRxErrorCounter[57]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[57]);
		BcuRxErrorCounter[58]++; // can msg 0x872
		// if(BcuRxErrorCounter[58]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[58]);
		BcuRxErrorCounter[59]++; // can msg 0x873
		// if(BcuRxErrorCounter[59]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[59]);
		BcuRxErrorCounter[60]++; // can msg 0x874
		// if(BcuRxErrorCounter[60]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[60]);
		BcuRxErrorCounter[61]++; // can msg 0x875
		// if(BcuRxErrorCounter[61]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[61]);
		BcuRxErrorCounter[62]++; // can msg 0x876
		// if(BcuRxErrorCounter[62]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[62]);
		BcuRxErrorCounter[63]++; // can msg 0x877
		// if(BcuRxErrorCounter[63]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[63]);
		BcuRxErrorCounter[64]++; // can msg 0x878
		// if(BcuRxErrorCounter[64]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[64]);
		BcuRxErrorCounter[65]++; // can msg 0x879
		// if(BcuRxErrorCounter[65]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[65]);
		BcuRxErrorCounter[66]++; // can msg 0x87A
		// if(BcuRxErrorCounter[66]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[66]);
		BcuRxErrorCounter[67]++; // can msg 0x87B
		// if(BcuRxErrorCounter[67]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[67]);
		BcuRxErrorCounter[68]++; // can msg 0x87C
		// if(BcuRxErrorCounter[68]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[68]);
		BcuRxErrorCounter[69]++; // can msg 0x87D
		// if(BcuRxErrorCounter[69]>=13)
		// printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[69]);
		BcuRxErrorCounter[70]++; // can msg 0x87E
								 // if(BcuRxErrorCounter[70]>=13)
								 // printf("can msg 0x%x lost,cycle time1000ms\n",COMInTable[70]);
	}
}
void BcuRxMsgSetInvalidValue(uint32 ID)
{
	switch (ID)
	{
	case 0x721:
		VcuBcuOperModReq = 0xFF;
		break;
	case 0x830:
		BcuSoc = 0xFFFF;
		BcuErrCode = 0xFFFF;
		BcuErrRank = 0xFF;
		BcuErrNum = 0xFF;
		BcuUpAlw = 0xFF;
		BcuInsulationR = 0xFFFF;
		BcuOperMod = 0xFF;
		break;
	case 0x831:
		BcuBattI1 = 0xFFFF;
		BcuBattI2 = 0xFFFF;
		BcuBattU1 = 0xFFFF;
		BcuBattU2 = 0xFFFF;
		break;
	case 0x832:
		BcuChrgMod = 0xFF;
		BcuChrgSt = 0xFF;
		BcuChrgIReq = 0xFFFF;
		BcuChrgUReq = 0xFFFF;
		BcuReChrgTm = 0xFFFF;
		BcuChrgEndReason = 0xFF;
		break;
	case 0x833:
		BcuDisChrPwrMaxLong = 0xFFFF;
		BcuChrPwrMaxLong = 0xFFFFFFFF;
		break;
	case 0x834:
		BcuSoh = 0xFFFF;
		BcuCellNr = 0xFF;
		BcuCellCap = 0xFFFF;
		BcuCellR = 0xFFFF;
		break;
	case 0x835:
		BcuReEgy = 0xFFFF;
		BcuSoe = 0xFFFF;
		break;
	case 0x837:
		BcuAhSoc = 0xFFFF;
		BcuBattSoc = 0xFFFF;
		BcuEKFSoc = 0xFFFF;
		break;
	case 0x840:
		BcuEquilist[0] = 0xFFFF;
		BcuEquilist[1] = 0xFFFF;
		BcuEquilist[2] = 0xFFFF;
		BcuEquilist[3] = 0xFFFF;
		break;
	case 0x841:
		BcuEquilist[4] = 0xFFFF;
		BcuEquilist[5] = 0xFFFF;
		BcuEquilist[6] = 0xFFFF;
		BcuEquilist[7] = 0xFFFF;
		break;
	case 0x842:
		BcuEquilist[8] = 0xFFFF;
		BcuEquilist[9] = 0xFFFF;
		BcuEquilist[10] = 0xFFFF;
		BcuEquilist[11] = 0xFFFF;
		break;
	case 0x843:
		BcuCellU[0] = 0xFFFF;
		BcuCellU[1] = 0xFFFF;
		BcuCellU[2] = 0xFFFF;
		BcuCellU[3] = 0xFFFF;
		break;
	case 0x844:
		BcuCellU[4] = 0xFFFF;
		BcuCellU[5] = 0xFFFF;
		BcuCellU[6] = 0xFFFF;
		BcuCellU[7] = 0xFFFF;
		break;
	case 0x845:
		BcuCellU[8] = 0xFFFF;
		BcuCellU[9] = 0xFFFF;
		BcuCellU[10] = 0xFFFF;
		BcuCellU[11] = 0xFFFF;
		break;
	case 0x846:
		BcuCellU[12] = 0xFFFF;
		BcuCellU[13] = 0xFFFF;
		BcuCellU[14] = 0xFFFF;
		BcuCellU[15] = 0xFFFF;
		break;
	case 0x847:
		BcuCellU[16] = 0xFFFF;
		BcuCellU[17] = 0xFFFF;
		BcuCellU[18] = 0xFFFF;
		BcuCellU[19] = 0xFFFF;
		break;
	case 0x848:
		BcuCellU[20] = 0xFFFF;
		BcuCellU[21] = 0xFFFF;
		BcuCellU[22] = 0xFFFF;
		BcuCellU[23] = 0xFFFF;
		break;
	case 0x849:
		BcuCellU[24] = 0xFFFF;
		BcuCellU[25] = 0xFFFF;
		BcuCellU[26] = 0xFFFF;
		BcuCellU[27] = 0xFFFF;
		break;
	case 0x84A:
		BcuCellU[28] = 0xFFFF;
		BcuCellU[29] = 0xFFFF;
		BcuCellU[30] = 0xFFFF;
		BcuCellU[31] = 0xFFFF;
		break;
	case 0x84B:
		BcuCellU[32] = 0xFFFF;
		BcuCellU[33] = 0xFFFF;
		BcuCellU[34] = 0xFFFF;
		BcuCellU[35] = 0xFFFF;
		break;
	case 0x84C:
		BcuCellU[36] = 0xFFFF;
		BcuCellU[37] = 0xFFFF;
		BcuCellU[38] = 0xFFFF;
		BcuCellU[39] = 0xFFFF;
		break;
	case 0x84D:
		BcuCellU[40] = 0xFFFF;
		BcuCellU[41] = 0xFFFF;
		BcuCellU[42] = 0xFFFF;
		BcuCellU[43] = 0xFFFF;
		break;
	case 0x84E:
		BcuCellU[44] = 0xFFFF;
		BcuCellU[45] = 0xFFFF;
		BcuCellU[46] = 0xFFFF;
		BcuCellU[47] = 0xFFFF;
		break;
	case 0x84F:
		BcuCellU[48] = 0xFFFF;
		BcuCellU[49] = 0xFFFF;
		BcuCellU[50] = 0xFFFF;
		BcuCellU[51] = 0xFFFF;
		break;
	case 0x850:
		BcuCellU[52] = 0xFFFF;
		BcuCellU[53] = 0xFFFF;
		BcuCellU[54] = 0xFFFF;
		BcuCellU[55] = 0xFFFF;
		break;
	case 0x851:
		BcuCellU[56] = 0xFFFF;
		BcuCellU[57] = 0xFFFF;
		BcuCellU[58] = 0xFFFF;
		BcuCellU[59] = 0xFFFF;
		break;
	case 0x852:
		BcuCellU[60] = 0xFFFF;
		BcuCellU[61] = 0xFFFF;
		BcuCellU[62] = 0xFFFF;
		BcuCellU[63] = 0xFFFF;
		break;
	case 0x853:
		BcuCellU[64] = 0xFFFF;
		BcuCellU[65] = 0xFFFF;
		BcuCellU[66] = 0xFFFF;
		BcuCellU[67] = 0xFFFF;
		break;
	case 0x854:
		BcuCellU[68] = 0xFFFF;
		BcuCellU[69] = 0xFFFF;
		BcuCellU[70] = 0xFFFF;
		BcuCellU[71] = 0xFFFF;
		break;
	case 0x855:
		BcuCellU[72] = 0xFFFF;
		BcuCellU[73] = 0xFFFF;
		BcuCellU[74] = 0xFFFF;
		BcuCellU[75] = 0xFFFF;
		break;
	case 0x856:
		BcuCellU[76] = 0xFFFF;
		BcuCellU[77] = 0xFFFF;
		BcuCellU[78] = 0xFFFF;
		BcuCellU[79] = 0xFFFF;
		break;
	case 0x857:
		BcuCellU[80] = 0xFFFF;
		BcuCellU[81] = 0xFFFF;
		BcuCellU[82] = 0xFFFF;
		BcuCellU[83] = 0xFFFF;
		break;
	case 0x858:
		BcuCellU[84] = 0xFFFF;
		BcuCellU[85] = 0xFFFF;
		BcuCellU[86] = 0xFFFF;
		BcuCellU[87] = 0xFFFF;
		break;
	case 0x859:
		BcuCellU[88] = 0xFFFF;
		BcuCellU[89] = 0xFFFF;
		BcuCellU[90] = 0xFFFF;
		BcuCellU[91] = 0xFFFF;
		break;
	case 0x85A:
		BcuCellU[92] = 0xFFFF;
		BcuCellU[93] = 0xFFFF;
		BcuCellU[94] = 0xFFFF;
		BcuCellU[95] = 0xFFFF;
		break;
	case 0x85B:
		BcuCellU[96] = 0xFFFF;
		BcuCellU[97] = 0xFFFF;
		BcuCellU[98] = 0xFFFF;
		BcuCellU[99] = 0xFFFF;
		break;
	case 0x85C:
		BcuCellU[100] = 0xFFFF;
		BcuCellU[101] = 0xFFFF;
		BcuCellU[102] = 0xFFFF;
		BcuCellU[103] = 0xFFFF;
		break;
	case 0x85D:
		BcuCellU[104] = 0xFFFF;
		BcuCellU[105] = 0xFFFF;
		BcuCellU[106] = 0xFFFF;
		BcuCellU[107] = 0xFFFF;
		break;
	case 0x85E:
		BcuCellU[108] = 0xFFFF;
		BcuCellU[109] = 0xFFFF;
		BcuCellU[110] = 0xFFFF;
		BcuCellU[111] = 0xFFFF;
		break;
	case 0x85F:
		BcuCellU[112] = 0xFFFF;
		BcuCellU[113] = 0xFFFF;
		BcuCellU[114] = 0xFFFF;
		BcuCellU[115] = 0xFFFF;
		break;
	case 0x860:
		BcuCellU[116] = 0xFFFF;
		BcuCellU[117] = 0xFFFF;
		BcuCellU[118] = 0xFFFF;
		BcuCellU[119] = 0xFFFF;
		break;
	case 0x861:
		BcuCellU[120] = 0xFFFF;
		BcuCellU[121] = 0xFFFF;
		BcuCellU[122] = 0xFFFF;
		BcuCellU[123] = 0xFFFF;
		break;
	case 0x862:
		BcuCellU[124] = 0xFFFF;
		BcuCellU[125] = 0xFFFF;
		BcuCellU[126] = 0xFFFF;
		BcuCellU[127] = 0xFFFF;
		break;
	case 0x863:
		BcuCellU[128] = 0xFFFF;
		BcuCellU[129] = 0xFFFF;
		BcuCellU[130] = 0xFFFF;
		BcuCellU[131] = 0xFFFF;
		break;
	case 0x864:
		BcuCellU[132] = 0xFFFF;
		BcuCellU[133] = 0xFFFF;
		BcuCellU[134] = 0xFFFF;
		BcuCellU[135] = 0xFFFF;
		break;
	case 0x865:
		BcuCellU[136] = 0xFFFF;
		BcuCellU[137] = 0xFFFF;
		BcuCellU[138] = 0xFFFF;
		BcuCellU[139] = 0xFFFF;
		break;
	case 0x866:
		BcuCellU[140] = 0xFFFF;
		BcuCellU[141] = 0xFFFF;
		BcuCellU[142] = 0xFFFF;
		BcuCellU[143] = 0xFFFF;
		break;
	case 0x867:
		BcuCellU[144] = 0xFFFF;
		BcuCellU[145] = 0xFFFF;
		BcuCellU[146] = 0xFFFF;
		BcuCellU[147] = 0xFFFF;
		break;
	case 0x868:
		BcuCellU[148] = 0xFFFF;
		BcuCellU[149] = 0xFFFF;
		BcuCellU[150] = 0xFFFF;
		BcuCellU[151] = 0xFFFF;
		break;
	case 0x869:
		BcuCellU[152] = 0xFFFF;
		BcuCellU[153] = 0xFFFF;
		BcuCellU[154] = 0xFFFF;
		BcuCellU[155] = 0xFFFF;
		break;
	case 0x86A:
		BcuCellU[156] = 0xFFFF;
		BcuCellU[157] = 0xFFFF;
		BcuCellU[158] = 0xFFFF;
		BcuCellU[159] = 0xFFFF;
		break;
	case 0x86B:
		BcuCellU[160] = 0xFFFF;
		BcuCellU[161] = 0xFFFF;
		BcuCellU[162] = 0xFFFF;
		BcuCellU[163] = 0xFFFF;
		break;
	case 0x86C:
		BcuCellU[164] = 0xFFFF;
		BcuCellU[165] = 0xFFFF;
		BcuCellU[166] = 0xFFFF;
		BcuCellU[167] = 0xFFFF;
		break;
	case 0x86D:
		BcuCellU[168] = 0xFFFF;
		BcuCellU[169] = 0xFFFF;
		BcuCellU[170] = 0xFFFF;
		BcuCellU[171] = 0xFFFF;
		break;
	case 0x86E:
		BcuCellU[172] = 0xFFFF;
		BcuCellU[173] = 0xFFFF;
		BcuCellU[174] = 0xFFFF;
		BcuCellU[175] = 0xFFFF;
		break;
	case 0x86F:
		BcuCellU[176] = 0xFFFF;
		BcuCellU[177] = 0xFFFF;
		BcuCellU[178] = 0xFFFF;
		BcuCellU[179] = 0xFFFF;
		break;
	case 0x870:
		BcuCellU[180] = 0xFFFF;
		BcuCellU[181] = 0xFFFF;
		BcuCellU[182] = 0xFFFF;
		BcuCellU[183] = 0xFFFF;
		break;
	case 0x871:
		break;
	case 0x872:
		break;
	case 0x873:
		BcuModT[0] = 0xFF;
		BcuModT[1] = 0xFF;
		BcuModT[2] = 0xFF;
		BcuModT[3] = 0xFF;
		BcuModT[4] = 0xFF;
		BcuModT[5] = 0xFF;
		BcuModT[6] = 0xFF;
		BcuModT[7] = 0xFF;
		break;
	case 0x874:
		BcuModT[8] = 0xFF;
		BcuModT[9] = 0xFF;
		BcuModT[10] = 0xFF;
		BcuModT[11] = 0xFF;
		BcuModT[12] = 0xFF;
		BcuModT[13] = 0xFF;
		BcuModT[14] = 0xFF;
		BcuModT[15] = 0xFF;
		break;
	case 0x875:
		BcuModT[16] = 0xFF;
		BcuModT[17] = 0xFF;
		BcuModT[18] = 0xFF;
		BcuModT[19] = 0xFF;
		BcuModT[20] = 0xFF;
		BcuModT[21] = 0xFF;
		BcuModT[22] = 0xFF;
		BcuModT[23] = 0xFF;
		break;
	case 0x876:
		BcuModT[24] = 0xFF;
		BcuModT[25] = 0xFF;
		BcuModT[26] = 0xFF;
		BcuModT[27] = 0xFF;
		BcuModT[28] = 0xFF;
		BcuModT[29] = 0xFF;
		BcuModT[30] = 0xFF;
		BcuModT[31] = 0xFF;
		break;
	case 0x877:
		BcuModT[32] = 0xFF;
		BcuModT[33] = 0xFF;
		BcuModT[34] = 0xFF;
		BcuModT[35] = 0xFF;
		BcuModT[36] = 0xFF;
		BcuModT[37] = 0xFF;
		BcuModT[38] = 0xFF;
		BcuModT[39] = 0xFF;
		break;
	case 0x878:
		BcuModT[40] = 0xFF;
		BcuModT[41] = 0xFF;
		BcuModT[42] = 0xFF;
		BcuModT[43] = 0xFF;
		BcuModT[44] = 0xFF;
		BcuModT[45] = 0xFF;
		BcuModT[46] = 0xFF;
		BcuModT[47] = 0xFF;
		break;
	case 0x879:
		BcuModT[48] = 0xFF;
		BcuModT[49] = 0xFF;
		BcuModT[50] = 0xFF;
		BcuModT[51] = 0xFF;
		BcuModT[52] = 0xFF;
		BcuModT[53] = 0xFF;
		BcuModT[54] = 0xFF;
		BcuModT[55] = 0xFF;
		break;
	case 0x87A:
		BcuModT[56] = 0xFF;
		BcuModT[57] = 0xFF;
		BcuModT[58] = 0xFF;
		BcuModT[59] = 0xFF;
		BcuModT[60] = 0xFF;
		BcuModT[61] = 0xFF;
		BcuModT[62] = 0xFF;
		BcuModT[63] = 0xFF;
		break;
	case 0x87B:
		BcuModT[64] = 0xFF;
		BcuModT[65] = 0xFF;
		BcuModT[66] = 0xFF;
		BcuModT[67] = 0xFF;
		BcuModT[68] = 0xFF;
		BcuModT[69] = 0xFF;
		BcuModT[70] = 0xFF;
		BcuModT[71] = 0xFF;
		break;
	case 0x87C:
		BcuModT[72] = 0xFF;
		BcuModT[73] = 0xFF;
		BcuModT[74] = 0xFF;
		BcuModT[75] = 0xFF;
		BcuModT[76] = 0xFF;
		BcuModT[77] = 0xFF;
		BcuModT[78] = 0xFF;
		BcuModT[79] = 0xFF;
		break;
	case 0x87D:
		BcuModT[80] = 0xFF;
		BcuModT[81] = 0xFF;
		BcuModT[82] = 0xFF;
		BcuModT[83] = 0xFF;
		BcuModT[84] = 0xFF;
		BcuModT[85] = 0xFF;
		BcuModT[86] = 0xFF;
		BcuModT[87] = 0xFF;
		break;
	case 0x87E:
		BcuModT[88] = 0xFF;
		BcuModT[89] = 0xFF;
		BcuModT[90] = 0xFF;
		BcuModT[91] = 0xFF;
		BcuModT[92] = 0xFF;
		BcuModT[93] = 0xFF;
		BcuModT[94] = 0xFF;
		BcuModT[95] = 0xFF;
		break;
	default:
		break;
	}
}
#endif
